
#include "GraphicEngine\VideoEngine.h"
#include "GraphicEngine\Layer.h"
#include "InputEngine\CommonStructs.h"
#include "InputEngine\Keyboard.h"
#include "Exemplo1GameState.h"




Exemplo1GameState::Exemplo1GameState() {
	m_layer = new CF16VLayer();
	m_point.x =0;
	m_point.y =0;
	ReceiveKeyboardEvent(TRUE);
	m_loaded = false;
}

Exemplo1GameState::~Exemplo1GameState() {
	SAFE_DELETE(m_layer);
}

void	Exemplo1GameState::IncludeGameState() {
	GetVideoEngine()->SetCursorVisible(FALSE);
	m_layer->Create(GetVideoEngine(),"Winter.jpg") ;
}

void	Exemplo1GameState::RemoveGameState() {
	
}

void	Exemplo1GameState::KeyDown( int iKey ) {
	if( iKey == F16VK_ESCAPE) {
		GetGameManager()->Exit(0);

	}
}


HRESULT Exemplo1GameState::ProcessFrame(void) {
	
	CF16VSurface* back = GetVideoEngine()->GetBackBuffer();
	if (GetInputEngine()->GetKeyBoard()->GetKeyDown(F16VK_LEFT)) m_layer->ScrollLeft(3);
	if (GetInputEngine()->GetKeyBoard()->GetKeyDown(F16VK_RIGHT)) m_layer->ScrollRight(3);
	if (GetInputEngine()->GetKeyBoard()->GetKeyDown(F16VK_UP)) m_layer->ScrollUp(2);
	if (GetInputEngine()->GetKeyBoard()->GetKeyDown(F16VK_DOWN)) m_layer->ScrollDown(2);
	m_layer->Draw(back);
	return 0;
}
