
#include "GraphicEngine\VideoEngine.h"
#include "GraphicEngine\Layer.h"
#include "InputEngine\CommonStructs.h"
#include "InputEngine\Keyboard.h"
#include "InputEngine\Mouse.h"
#include "Exemplo3GameState.h"




Exemplo3GameState::Exemplo3GameState() {
	m_layer = new CF16VLayer();
	m_point.x =0;
	m_point.y =0;
	m_loaded = false;

	ReceiveKeyboardEvent(TRUE); //  preciso informar ao gameManager que este estado quer receber os eventos de teclado.
	ReceiveMouseEvent(TRUE);//  preciso informar ao gameManager que este estado quer receber os eventos de mouse.
}

Exemplo3GameState::~Exemplo3GameState() {
	SAFE_DELETE(m_layer);
}

void	Exemplo3GameState::IncludeGameState() {
	GetVideoEngine()->SetCursorVisible(false);
	m_layer->Create(GetVideoEngine(),"Winter.jpg") ;
}

void	Exemplo3GameState::RemoveGameState() {
	
}

void	Exemplo3GameState::KeyDown( int iKey ) {

}

void	Exemplo3GameState::MouseButtonDown(int iButton) {

}

HRESULT Exemplo3GameState::ProcessFrame(void) {
	
	CF16VSurface* back = GetVideoEngine()->GetBackBuffer();

	if (GetInputEngine()->GetKeyBoard()->GetKeyDown(F16VK_ESCAPE)) CF16VGameManager::GetGameManager()->Exit(0);

	if (GetInputEngine()->GetKeyBoard()->GetKeyDown(F16VK_LEFT)) m_layer->ScrollLeft(3);
	if (GetInputEngine()->GetKeyBoard()->GetKeyDown(F16VK_RIGHT)) m_layer->ScrollRight(3);
	if (GetInputEngine()->GetKeyBoard()->GetKeyDown(F16VK_UP)) m_layer->ScrollUp(2);
	if (GetInputEngine()->GetKeyBoard()->GetKeyDown(F16VK_DOWN)) m_layer->ScrollDown(2);

	m_layer->Draw(back);
	return 0;
}
